Index: kernel/application.php
===================================================================
--- kernel/application.php	(revision 15456)
+++ kernel/application.php	(working copy)
@@ -1201,6 +1201,7 @@
 	protected function _outputPage()
 	{
 		$this->setContentType();
+		ob_start();
 
 		if ( $this->UseOutputCompression() ) {
 			$compression_level = $this->ConfigValue('OutputCompressionLevel');
@@ -1213,10 +1214,23 @@
 			echo gzencode($this->HTML, $compression_level);
 		}
 		else {
+			// when gzip compression not used connection won't be closed early!
 			echo $this->HTML;
 		}
 
+		// send headers to tell the browser to close the connection
+		header('Content-Length: ' . ob_get_length());
+		header('Connection: close');
+
+		// flush all output
+		ob_end_flush();
+		ob_flush();
 		flush();
+
+		// close current session
+		if ( session_id() ) {
+			session_write_close();
+		}
 	}
 
 	/**
Index: kernel/managers/scheduled_task_manager.php
===================================================================
--- kernel/managers/scheduled_task_manager.php	(revision 15456)
+++ kernel/managers/scheduled_task_manager.php	(working copy)
@@ -110,6 +110,9 @@
 			return ;
 		}
 
+		ignore_user_abort(true);
+		set_time_limit(0);
+		
 		$events_source = $this->getAll();
 
 		$user_id = $this->Application->RecallVar('user_id');
